var generateResponsiveClasses = function (prefix, value, suffix) {
    var result = {};
    if (typeof value === 'string') {
        // Handle a single string value without breakpoints
        result["".concat(prefix, "-").concat(value)] = true;
    }
    else if (typeof value === 'boolean' && value === true && suffix) {
        // Handle a single boolean value with the provided suffix
        result["".concat(prefix, "-").concat(suffix)] = true;
    }
    else if (typeof value === 'object' && value !== null) {
        // Define an array of valid breakpoints
        var breakpoints = ['xs', 'sm', 'md', 'lg', 'xl', 'xxl'];
        for (var _i = 0, breakpoints_1 = breakpoints; _i < breakpoints_1.length; _i++) {
            var breakpoint = breakpoints_1[_i];
            var val = value[breakpoint];
            if (val) {
                if (typeof val === 'boolean' && val === true && suffix) {
                    // Handle boolean values for breakpoints with the provided suffix
                    if (breakpoint === 'xs') {
                        result["".concat(prefix, "-").concat(suffix)] = true;
                    }
                    else {
                        result["".concat(prefix, "-").concat(breakpoint, "-").concat(suffix)] = true;
                    }
                }
                else {
                    // Handle string values for breakpoints
                    if (breakpoint === 'xs') {
                        result["".concat(prefix, "-").concat(val)] = true;
                    }
                    else {
                        result["".concat(prefix, "-").concat(breakpoint, "-").concat(val)] = true;
                    }
                }
            }
        }
    }
    return result;
};
export default generateResponsiveClasses;
