import React from 'react';
import type { TBoxAlign, TBoxAlignItems, TBoxAlignSelf, TBoxBorderWidth, TBoxDisplay, TBoxFlexDirection, TBoxFlexWrap, TBoxFontSize, TBoxFontWeight, TBoxJustifyContent, TBoxOpacity, TBoxOverflow, TBoxPointerEvents, TBoxRadius, TBoxSizing, TBoxSpacing, TBoxTextAlign, TBoxTextTransform, TBoxUserSelect, TResponsiveValue } from '../../types';
export interface BoxProps extends React.HTMLAttributes<HTMLElement> {
    as?: keyof React.ReactHTML;
    align?: TBoxAlign;
    alignItems?: TResponsiveValue<TBoxAlignItems>;
    alignSelf?: TResponsiveValue<TBoxAlignSelf>;
    background?: string;
    border?: boolean;
    borderTop?: boolean | 0;
    borderEnd?: boolean | 0;
    borderBottom?: boolean | 0;
    borderStart?: boolean | 0;
    borderColor?: string;
    borderWidth?: TBoxBorderWidth;
    color?: string;
    display?: TResponsiveValue<TBoxDisplay>;
    flexDirection?: TResponsiveValue<TBoxFlexDirection>;
    flexFill?: TResponsiveValue<boolean>;
    flexWrap?: TResponsiveValue<TBoxFlexWrap>;
    fontSize?: TBoxFontSize;
    fontWeight?: TBoxFontWeight;
    gradient?: boolean;
    height?: TBoxSizing;
    invisible?: boolean;
    justifyContent?: TResponsiveValue<TBoxJustifyContent>;
    margin?: TResponsiveValue<TBoxSpacing>;
    marginTop?: TResponsiveValue<TBoxSpacing>;
    marginBottom?: TResponsiveValue<TBoxSpacing>;
    marginLeft?: TResponsiveValue<TBoxSpacing>;
    marginRight?: TResponsiveValue<TBoxSpacing>;
    marginX?: TResponsiveValue<TBoxSpacing>;
    marginY?: TResponsiveValue<TBoxSpacing>;
    opacity?: TBoxOpacity;
    overflow?: TBoxOverflow;
    padding?: TResponsiveValue<TBoxSpacing>;
    paddingTop?: TResponsiveValue<TBoxSpacing>;
    paddingBottom?: TResponsiveValue<TBoxSpacing>;
    paddingLeft?: TResponsiveValue<TBoxSpacing>;
    paddingRight?: TResponsiveValue<TBoxSpacing>;
    paddingX?: TResponsiveValue<TBoxSpacing>;
    paddingY?: TResponsiveValue<TBoxSpacing>;
    pointerEvents?: TBoxPointerEvents;
    radius?: TBoxRadius;
    textAlign?: TResponsiveValue<TBoxTextAlign>;
    textWrap?: boolean;
    textNoWrap?: boolean;
    textTransform?: TBoxTextTransform;
    userSelect?: TBoxUserSelect;
    visible?: boolean;
    width?: TBoxSizing;
    wordBreak?: boolean;
}
declare const Box: React.FC<BoxProps>;
export default Box;
